import { NgModule } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { SharedModule } from './shared/shared.module';
import { BrowserModule } from '@angular/platform-browser';
import { NoopAnimationsModule } from '@angular/platform-browser/animations';
import { APP_BASE_HREF, CommonModule } from '@angular/common';
import { HttpClientModule } from '@angular/common/http';
import { RouterModule } from '@angular/router';
import { AppComponent } from './app.component';
import {NavigationBarModule} from './sharedComponents/navigationBar.module';
import { CookieLawModule } from './sharedComponents/cookie-law/cookie-law.module';
import { BottomModule } from './sharedComponents/bottom.module';
// import { ErrorModule } from './error/error.module';
import { ConfigurationService } from './utils/configuration/configuration.service';
import {MainSearchModule} from './searchPages/find/mainSearch.module';
import {PublicationModule} from './landingPages/publication/publication.module';
import {DatasetModule} from './landingPages/dataset/dataset.module';
import {SoftwareModule} from './landingPages/software/software.module';
import {OrpModule} from './landingPages/orp/orp.module';
import {DataProviderModule} from './landingPages/dataProvider/dataProvider.module';
import {ProjectModule} from './landingPages/project/project.module';
import {OrganizationModule} from './landingPages/organization/organization.module';
import {ReloadModule} from './reload/reload.module';
import {ErrorModule} from './error/error.module';
import {DepositDatasetsModule} from './deposit/datasets/depositDatasets.module';
import {DepositDatasetsResultsModule} from './deposit/datasets/depositDatasetsResults.module';
import {DepositBySubjectResultsModule} from './deposit/datasets/depositBySubjectResults.module';
import {DepositPublicationsModule} from './deposit/publications/depositPublications.module';
import {DepositPublicationsResultsModule} from './deposit/publications/depositPublicationsResults.module';

import {SearchPublicationsModule} from './searchPages/simple/searchPublications.module';
import {SearchDatasetsModule} from './searchPages/simple/searchDatasets.module';
import {SearchSoftwareModule} from './searchPages/simple/searchSoftware.module';
import {SearchOrpsModule} from './searchPages/simple/searchOrps.module';
import {SearchDataProvidersModule} from './searchPages/simple/searchDataProviders.module';
import {SearchProjectsModule} from './searchPages/simple/searchProjects.module';
import {SearchOrganizationsModule} from './searchPages/simple/searchOrganizations.module';

import {AdvancedSearchPublicationsModule} from './searchPages/advanced/advancedSearchPublications.module';
import {AdvancedSearchDatasetsModule} from './searchPages/advanced/advancedSearchDatasets.module';
import {AdvancedSearchSoftwareModule} from './searchPages/advanced/advancedSearchSoftware.module';
import {AdvancedSearchOrpsModule} from './searchPages/advanced/advancedSearchOrps.module';
import {AdvancedSearchDataProvidersModule} from './searchPages/advanced/advancedSearchDataProviders.module';
import {AdvancedSearchProjectsModule} from './searchPages/advanced/advancedSearchProjects.module';
import {AdvancedSearchOrganizationsModule} from './searchPages/advanced/advancedSearchOrganizations.module';

import {EntityRegistriesModule} from './searchPages/dataProviders/entityRegistries.module';
import {EntityRegistriesTableModule} from './searchPages/dataProviders/entityRegistriesTable.module';

import {JournalsTableModule} from './searchPages/dataProviders/journalsTable.module';
import {JournalsModule} from './searchPages/dataProviders/journals.module';


import {CompatibleDataProvidersModule} from './searchPages/dataProviders/compatibleDataProviders.module';
import {CompatibleDataProvidersTableModule} from './searchPages/dataProviders/compatibleDataProvidersTable.module';

import {ClaimsAdminModule} from './claims/claimsAdmin/claimsAdmin.module';
import {MyClaimsModule} from './claims/myClaims/myClaims.module';
import {ClaimsByTokenModule} from './claims/claimsByToken/claimsByToken.module';
import {DirectLinkingModule} from './claims/directLinking/directLinking.module';
import {LinkingGenericModule} from './claims/linking/linkingGeneric.module';

import{ HtmlProjectReportModule} from './landingPages/htmlProjectReport/htmlProjectReport.module';
import {IsRouteEnabled} from './error/isRouteEnabled.guard';
import { AppRoutingModule } from './app-routing.module';
@NgModule({

  imports: [
    SharedModule,
    NoopAnimationsModule,
    CommonModule,
    CookieLawModule,
    BottomModule,
    HttpClientModule,
    NavigationBarModule,
    MainSearchModule,
    ErrorModule,
    DepositDatasetsModule,DepositDatasetsResultsModule, DepositBySubjectResultsModule,DepositPublicationsModule , DepositPublicationsResultsModule,
    SearchPublicationsModule,SearchDatasetsModule, SearchSoftwareModule, SearchOrpsModule, SearchDataProvidersModule, SearchProjectsModule, SearchOrganizationsModule,
    AdvancedSearchPublicationsModule,AdvancedSearchDatasetsModule, AdvancedSearchSoftwareModule, AdvancedSearchOrpsModule, AdvancedSearchDataProvidersModule, AdvancedSearchProjectsModule, AdvancedSearchOrganizationsModule,
    PublicationModule, DatasetModule, DataProviderModule, OrganizationModule, ProjectModule, SoftwareModule, OrpModule,
    EntityRegistriesModule, CompatibleDataProvidersModule, JournalsModule,
    JournalsTableModule, EntityRegistriesTableModule, CompatibleDataProvidersTableModule,
    ClaimsAdminModule, MyClaimsModule, ClaimsByTokenModule, LinkingGenericModule, DirectLinkingModule,
    HtmlProjectReportModule,
    BrowserModule.withServerTransition({appId: 'my-app'}),
   AppRoutingModule
  ],
  declarations: [ AppComponent ],
  exports: [ AppComponent ],
 providers:[ ConfigurationService],
 bootstrap: [AppComponent]
})
export class AppModule {}
/*

, canActivate: [ IsRouteEnabled], data: {
  redirect: '/error'
}
*/
