import { NgModule } from '@angular/core';

import { SharedModule } from '../../shared/shared.module';
import { CommonModule }        from '@angular/common';
import {ClaimResultSearchFormComponent} from './claimResultSearchForm.component';
import {ClaimResultsComponent} from './claimResults.component';

import {SearchDataciteServiceModule} from './service/searchDataciteService.module';

import {SearchCrossrefServiceModule} from './service/searchCrossrefService.module';
import {SearchOrcidService} from './service/searchOrcid.service';

import {PublicationsServiceModule} from '../../services/publicationsService.module';
import {DatasetsServiceModule} from '../../services/datasetsService.module';
import {SoftwareServiceModule} from '../../services/softwareService.module';
import {OrpsServiceModule} from '../../services/orpsService.module';
import {PagingModule } from '../../utils/paging.module';
import {HelperModule} from '../../utils/helper/helper.module';

 @NgModule({
  imports: [SharedModule, CommonModule, PublicationsServiceModule, DatasetsServiceModule, PagingModule, SearchCrossrefServiceModule,
    SearchDataciteServiceModule,SoftwareServiceModule, OrpsServiceModule, HelperModule],
  providers:[
     SearchOrcidService
  ],
  declarations: [
     ClaimResultSearchFormComponent, ClaimResultsComponent

  ],
  exports: [ClaimResultSearchFormComponent, ClaimResultsComponent ]
})
export class ClaimResultSearchFormModule { }
