// import {MaterialModule}             from '@angular/material';
import {NgModule}                   from '@angular/core';
import {CommonModule}               from '@angular/common';
import {FormsModule}                from '@angular/forms';
import {RouterModule}               from '@angular/router';

import {SharedModule}               from '../../shared/shared.module';

import {DatasetComponent}           from './dataset.component';

import {CiteThisModule}             from '../landing-utils/citeThis/citeThis.module';
// import {DatasetRoutingModule}       from './dataset-routing.module';
import {LandingModule}              from '../landing-utils/landing.module';
import {ResultLandingModule}        from '../landing-utils/resultLanding.module';
import {MetricsModule}              from '../landing-utils/metrics.module';
import {AltMetricsModule}           from '../../utils/altmetrics.module';
import {ConfigurationServiceModule} from '../../utils/configuration/configurationService.module';
import {IFrameModule}               from '../../utils/iframe.module';
import {PagingModule}               from '../../utils/paging.module';

import {DatasetService}             from './dataset.service';

import {FreeGuard}                  from'../../login/freeGuard.guard';
import {IsRouteEnabled}             from '../../error/isRouteEnabled.guard';
import {Schema2jsonldModule} from '../../sharedComponents/schema2jsonld/schema2jsonld.module';
import { SEOServiceModule } from '../../sharedComponents/SEO/SEOService.module';

import {ShowAuthorsModule}        from "../../utils/authors/showAuthors.module";

@NgModule({
  imports: [
    //MaterialModule.forRoot(),
    CommonModule, FormsModule, SharedModule, RouterModule, LandingModule,
    CiteThisModule, ResultLandingModule, MetricsModule, IFrameModule, PagingModule,
    AltMetricsModule, ConfigurationServiceModule, Schema2jsonldModule, SEOServiceModule,
    ShowAuthorsModule
  ],
  declarations: [
    DatasetComponent
  ],
  providers:[
    DatasetService, FreeGuard, IsRouteEnabled
  ],
  exports: [
    DatasetComponent
  ]
})

export class DatasetModule { }
