//import {MaterialModule} from '@angular/material';
import {NgModule}                     from '@angular/core';
import {CommonModule}                 from '@angular/common';
import {FormsModule}                  from '@angular/forms';
import {RouterModule}                 from '@angular/router';

// import { PublicationRoutingModule } from './publication-routing.module';
import {SharedModule}                 from '../../shared/shared.module';
import {MetricsModule}                from '../landing-utils/metrics.module';
import {ResultLandingModule}          from '../landing-utils/resultLanding.module';
import {LandingModule}                from '../landing-utils/landing.module';
import {CiteThisModule}               from '../landing-utils/citeThis/citeThis.module';
import {IFrameModule}                 from '../../utils/iframe.module';
import {AltMetricsModule}             from '../../utils/altmetrics.module';
import {PagingModule}                 from '../../utils/paging.module';
import {ConfigurationServiceModule}   from '../../utils/configuration/configurationService.module';

import {FreeGuard}                    from'../../login/freeGuard.guard';
import {IsRouteEnabled}               from '../../error/isRouteEnabled.guard';
import {PublicationService}           from './publication.service';
import {PublicationComponent}         from './publication.component';
import {Schema2jsonldModule} from '../../sharedComponents/schema2jsonld/schema2jsonld.module';
import { SEOServiceModule } from '../../sharedComponents/SEO/SEOService.module';

import {DeletedByInferenceModule} from '../landing-utils/deletedByInference/deletedByInference.module';
import {ShowAuthorsModule}        from "../../utils/authors/showAuthors.module";

@NgModule({
  imports: [
    CommonModule, FormsModule, LandingModule, SharedModule, RouterModule,
    CiteThisModule, PagingModule, ResultLandingModule, IFrameModule,
    MetricsModule, AltMetricsModule, ConfigurationServiceModule, Schema2jsonldModule, SEOServiceModule,
    DeletedByInferenceModule, ShowAuthorsModule
  ],
  declarations: [
    PublicationComponent
  ],
  providers: [
    PublicationService, FreeGuard, IsRouteEnabled
  ],
  exports: [
    PublicationComponent
  ]
})
export class PublicationModule { }
