//import {MaterialModule} from '@angular/material';
import { NgModule }            from '@angular/core';
import { CommonModule }        from '@angular/common';
import { FormsModule }         from '@angular/forms';

import { RouterModule } from '@angular/router';

import { SoftwareService } from './software.service';
import { SoftwareComponent } from './software.component';
// import { SoftwareRoutingModule } from './software-routing.module';
import { MetricsModule } from '../landing-utils/metrics.module';
import { IFrameModule } from '../../utils/iframe.module';
import { AltMetricsModule } from '../../utils/altmetrics.module';
import { CiteThisModule } from '../landing-utils/citeThis/citeThis.module';
import { PagingModule } from '../../utils/paging.module';

import { ResultLandingModule } from '../landing-utils/resultLanding.module';
import { LandingModule } from '../landing-utils/landing.module';
import { FreeGuard } from'../../login/freeGuard.guard';
import {Schema2jsonldModule} from '../../sharedComponents/schema2jsonld/schema2jsonld.module';
import { SEOServiceModule } from '../../sharedComponents/SEO/SEOService.module';
import {ShowAuthorsModule}        from "../../utils/authors/showAuthors.module";

@NgModule({
  imports: [
    CommonModule, FormsModule, LandingModule,  RouterModule, CiteThisModule, PagingModule,
    ResultLandingModule,   IFrameModule, MetricsModule, AltMetricsModule, Schema2jsonldModule, SEOServiceModule,
    ShowAuthorsModule
  ],
  declarations: [
    SoftwareComponent
  ],
  providers:[
    SoftwareService, FreeGuard
  ],
  exports: [
    SoftwareComponent
  ]
})
export class SoftwareModule { }
