import { NgModule}            from '@angular/core';
import { CommonModule }        from '@angular/common';
import { FormsModule }         from '@angular/forms';
import { RouterModule } from '@angular/router';

// import{MainSearchRoutingModule} from './mainSearch-routing.module';
import{SearchComponent} from './search.component';

import {SearchResultsModule } from '../searchUtils/searchResults.module';

import {DataProvidersServiceModule} from '../../services/dataProvidersService.module';
import {DatasetsServiceModule} from '../../services/datasetsService.module';
import {SoftwareServiceModule} from '../../services/softwareService.module';
import {OrpsServiceModule} from '../../services/orpsService.module';
import {ProjectsServiceModule} from '../../services/projectsService.module';
import {PublicationsServiceModule} from '../../services/publicationsService.module';
import {OrganizationsServiceModule} from '../../services/organizationsService.module';
import {BrowseEntitiesModule} from '../searchUtils/browseEntities.module';
import {SearchFormModule} from  '../searchUtils/searchForm.module';
import {Schema2jsonldModule} from '../../sharedComponents/schema2jsonld/schema2jsonld.module';

import {PiwikServiceModule} from '../../utils/piwik/piwikService.module';
import { SEOServiceModule } from '../../sharedComponents/SEO/SEOService.module';

@NgModule({
  imports: [
    CommonModule, FormsModule, RouterModule,
    DataProvidersServiceModule, DatasetsServiceModule, SoftwareServiceModule, OrpsServiceModule, ProjectsServiceModule,
    PublicationsServiceModule, OrganizationsServiceModule,
    BrowseEntitiesModule, SearchFormModule, SearchResultsModule,  PiwikServiceModule, Schema2jsonldModule, SEOServiceModule

  ],
  declarations: [
    SearchComponent
   ],
  providers:[
    //FreeGuard, PreviousRouteRecorder
    ],
  exports: [
    SearchComponent
     ]
})
export class MainSearchModule { }
