import { NgModule}            from '@angular/core';
import { CommonModule }        from '@angular/common';
import { FormsModule }         from '@angular/forms';

import{SearchDatasetsComponent} from './searchDatasets.component';

import {SearchResultsModule } from '../searchUtils/searchResults.module';

import {DatasetsServiceModule} from '../../services/datasetsService.module';
import {SearchFormModule} from  '../searchUtils/searchForm.module';
//import {SearchFilterModalModule} from '../searchUtils/searchFilterModal.module';
import {SearchPageModule} from '../searchUtils/searchPage.module';
import {FreeGuard} from'../../login/freeGuard.guard';
import {IsRouteEnabled} from '../../error/isRouteEnabled.guard';

@NgModule({
  imports: [
    CommonModule, FormsModule,

    DatasetsServiceModule,
     SearchFormModule, SearchResultsModule,  SearchPageModule

  ],
  declarations: [
    SearchDatasetsComponent
   ],
  providers:[FreeGuard, IsRouteEnabled],
  exports: [
    SearchDatasetsComponent
     ]
})
export class SearchDatasetsModule { }
