import { NgModule}            from '@angular/core';
import { CommonModule }        from '@angular/common';
import { FormsModule }         from '@angular/forms';

import{SearchOrpsComponent} from './searchOrps.component';

import {SearchResultsModule } from '../searchUtils/searchResults.module';

import {OrpsServiceModule} from '../../services/orpsService.module';
import {SearchFormModule} from  '../searchUtils/searchForm.module';
//import {SearchFilterModalModule} from '../searchUtils/searchFilterModal.module';
import {SearchPageModule} from '../searchUtils/searchPage.module';
import {FreeGuard} from'../../login/freeGuard.guard';
import {IsRouteEnabled} from '../../error/isRouteEnabled.guard';

@NgModule({
  imports: [
    CommonModule, FormsModule,

    OrpsServiceModule,
    SearchFormModule, SearchResultsModule,  SearchPageModule

  ],
  declarations: [
    SearchOrpsComponent
   ],
  providers:[FreeGuard, IsRouteEnabled],
  exports: [
    SearchOrpsComponent
     ]
})
export class SearchOrpsModule { }
