import { NgModule}            from '@angular/core';
import { CommonModule }        from '@angular/common';
import { FormsModule }         from '@angular/forms';

import{SearchPublicationsComponent} from './searchPublications.component';

import {SearchResultsModule } from '../searchUtils/searchResults.module';

import {PublicationsServiceModule} from '../../services/publicationsService.module';
import {SearchFormModule} from  '../searchUtils/searchForm.module';
//import {SearchFilterModalModule} from '../searchUtils/searchFilterModal.module';
import {SearchPageModule} from '../searchUtils/searchPage.module';
import {FreeGuard} from'../../login/freeGuard.guard';
import {IsRouteEnabled} from '../../error/isRouteEnabled.guard';

@NgModule({
  imports: [
    CommonModule, FormsModule,

    PublicationsServiceModule,
     SearchFormModule, SearchResultsModule, SearchPageModule

  ],
  declarations: [
    SearchPublicationsComponent
   ],
  providers:[FreeGuard, IsRouteEnabled],
  exports: [
    SearchPublicationsComponent
     ]
})
export class SearchPublicationsModule { }
