export class PublicationInfo {
    underCurationMessage: boolean;
    //title: { "name": string, "url": string, "accessMode": string};
    title: string;
    accessMode: string;
    authors: {"fullName": string, "orcid": string}[];
    date: string;
    dateofacceptance: string;
    embargoEndDate: string;
    types: string[];
    //downloadFrom: Map<string, {"url": string[], "accessMode": string[], "bestAccessMode": string}>;   //key is name
    //publishedIn: Map<string, {"url": string[], "accessMode": string[], "bestAccessMode": string}>;    //key is name

    hostedBy_collectedFrom: {"downloadName": string, "downloadUrl": string[], "collectedName": string, "collectedId": string, "accessMode": string[], "bestAccessMode": string, "type": string, "year":string}[];

    identifiers: Map<string, string[]>;     //key is the classname
    publisher: string;
    journal: {"journal": string, "issn": string, "lissn": string, "eissn": string, "issue": string, "volume": string, "start_page": string, "end_page": string};
    languages: string[];
    countries: string[];
    subjects: string[];
    otherSubjects: Map<string, string[]>;
    classifiedSubjects: Map<string, string[]>;          //<class of subject, subjects>
    description: string;
    //bestaccessright: string;
    //collectedFrom: { "name": string, "id": string}[];
    projectsProvenanceVocabulary: { "sysimport:crosswalk:repository": string,
                                    "sysimport:crosswalk:entityregistry": string,
                                    "sysimport:crosswalk:datasetarchive": string,
                                    "iis": string,
                                    "sysimport:mining:repository": string,
                                    "user:claim:pid": string,
                                    "user:claim:search": string,
                                    "user:claim:datacite": string
                                  } = {
                                    "sysimport:crosswalk:repository": "Repository",
                                    "sysimport:crosswalk:entityregistry": "Repository",
                                    "sysimport:crosswalk:datasetarchive": "Repository",
                                    "iis": "OpenAIRE",
                                    "sysimport:mining:repository": "OpenAIRE",
                                    "user:claim:pid": "User",
                                    "user:claim:search": "User",
                                    "user:claim:datacite": "User"
                                  };
    fundedByProjects: { "id": string, "acronym": string, "title": string,
                        "funderShortname": string, "funderName": string,
                        "funding": string, "code": string, "provenanceAction": string,
                        "inline": boolean}[];
    bioentities: Map<string, Map<string, string>>;      //<site name, <>>
    software: { "name": string, "url": string}[];      //<site name, <>>
    //relatedPublications: { "name": string, "url": string, "date": string, "trust": number}[];
    //relatedResearchData: { "name": string, "url": string, "date": string, "trust": number}[];
    //similarPublications: {"name": string, "url": string, "date": string, "trust": number}[];
    //similarDatasets: {"name": string, "url": string, "date": string, "trust": number}[];
    researchResultsProvenanceVocabulary: {"iis": string, "sysimport": string, "user": string} = {"iis": "Inferred", "sysimport": "Harvested", "user": "Claimed"};
    relatedResearchResults: Map<string, { "name": string, "id": string, "date": string, "percentage": number, "class": string}[]>;  // percentage is for trust
    similarResearchResults: { "name": string, "id": string, "date": string, "percentage": number, "class": string}[]; // percentage is for similarity
    references: { "name": string, "url": string}[];
    contexts: { "labelContext": string, "labelCategory": string, "labelConcept": string, "inline": boolean}[];
    organizations: {"name": string, "shortname":string, "id": string, "websiteUrl": string, "country": string, "trust": number}[];

    openCitations: {"url": string, "title": string, "year": string, "doi": string, "authors": string[]}[];

    record;

    deletedByInferenceIds: string[];
}
