import {CommunityInfo} from "../../connect/community/communityInfo";

export class SearchResult {
    title: { "name": string, "accessMode": string, "sc39": string};
    id:string;
    DOI:string;
    //publications & datasets & orp & organizations:
    projects: {"funderShortname": string, "funderName": string, "acronym": string, "title": string, "code": string, "id": string}[];

    //datasets & orp & publications & software
    description: string;
    year: string;
    embargoEndDate: string;
    authors: {"fullName": string, "orcid": string}[];

    //datasets & orp:
    publisher: string;

    //dataproviders & projects:
    organizations: { "name": string, "id": string}[];

    //projects:
    acronym: string;
    code: string;
    //funders: {"funderShortname": string, "funderName": string}[]; // not used
    funderShortname: string;
    startYear:number;
    endYear:number;
    openAccessMandatePublications: boolean;
    openAccessMandateDatasets: boolean;

    //organizations:
    country: string;

    //dataproviders:
    englishname: string;
    type: string;
    websiteURL: string;
    OAIPMHURL: string;
    compatibility: string;
    compatibilityUNKNOWN: boolean;
    countries: string[];
    subjects: string[];

    //publications & datasets & software & orp
    countriesForResults: string[];
    languages: string[];

    //software
    programmingLanguages: string[];

    entityType: string;
    types: string[];

    constructor(){}

}
